package agenda;

import element.IntElement;

/**
 * Priority queue agenda implementation where the priority of items
 * is determined by the first element of the item, when that element
 * is an integer element, or zero when it is not.
 * @author carlos
 *
 * Created at regulus, 11-nov-2006 13:25:19
 */
public class FirstElementPriorityQueueAgenda extends PriorityQueueAgenda
{
	
	/**
	 * Obtains the priority of an item.
	 * @param item
	 * @return The integer value of the first element of the item,
	 * if it is a nonnegative integer,
	 * or zero if the first element does not represent an integer
	 * number, or if it represents a negative number.
	 */
	protected int getPriority ( Object item )
	{
		Object[] theItem = (Object[]) item;
		Object firstElement = theItem[0];
		if ( firstElement instanceof IntElement )
		{
			int val = ( (IntElement)firstElement ).getValue();
			if ( val >= 0 ) return val;
			else return 0;
		}
		return 0;
	}
	
}