/*
 * Created on 09-ago-2004
 */
package element;

/**
 * @author carlos
 * 
 * Interfaz que implementarn los visitantes de elementos (segn el patrn de diseo
 * Visitante).
 */
public interface ElementVisitor 
{

	/**
	 * Mtodo para visitar un elemento simple.
	 * @param se Elemento a visitar.
	 */
	public void visitSimpleElement ( SimpleElement se );
	
	/**
	 * Mtodo para visitar un elemento compuesto.
	 * @param ce Elemento a visitar.
	 */
	public void visitCompositeElement ( CompositeElement ce );
	
	/**
	 * Mtodo para visitar un elemento de tipo expresin.
	 * @param ee Elemento a visitar.
	 */
	public void visitExpressionElement ( ExpressionElement ee );
	
	/**
	 * Mtodo para visitar un elemento de tipo secuencia.
	 * @param zome Elemento a visitar.
	 */
	public void visitSequenceElement ( SequenceElement zome );
	
}
