/*
 * Created at denebola on 27-mar-2004 11:35:22
 *
 */
package element;

/**
 * Una instancia de esta clase representa una expresin simple que nos da la longitud
 * de la cadena de entrada.
 * Modelamos esto como expresin porque, en efecto, se comporta como un elemento simple
 * cuando se conoce su valor. Su clase resultante es StringPosition, y el cdigo que
 * genera har una consulta al mtodo static de la clase StringPosition que nos da
 * la longitud de la cadena de entrada.
 */
public class SentenceLengthExpression extends ExpressionElement
{
	
    private SentenceLengthExpression()
    {
    	super ( new Element[0] ); //esta expresin no tiene hijos.
    }
    
    /**
     * La expresin longitud de la cadena de entrada devuelve como cdigo
     * Java una llamada al mtodo StringPosition.getMaxValue()
     */
    public String getExpressionCode ( String[] memberNames )
    {
        return "StringPosition.groundFromValue(StringPosition.getMaxValue())";
    }
    
    /**
     * Devuelve false.
     */
    public boolean isGround ()
    {
        return false;
    }
    
    /**
     * La clase resultante es la clase posicin de cadena de entrada.
     */
    public Class getResultingClass()
    {
        return StringPosition.class;
    }
    
    /**
     * El parsing es trivial, no nos fijamos en la cadena de entrada, simplemente
     * aceptamos aqullo que el usuario haya definido en el eparser como que representa
     * la longitud (lo normal sera que definiese como tal una cadena simple, no una
     * expresin regular)
     * @param s Cadena con la que se construir una expresin de este tipo.
     * @return Instancia de SentenceLengthExpression.
     */
    public static SentenceLengthExpression fromString ( String s )
    {
    	return new SentenceLengthExpression();
    }
    
}
