package grammar;

import element.*;

import java.util.*;
import java.io.*;

/**
 * Tipo de gramtica independiente del contexto que es automticamente
 * convertida a forma normal de Chomsky.
 *  
 * @author carlos
 *
 */
public class CNFContextFreeGrammar extends ContextFreeGrammar
{
		
	/**
	 * Construye y devuelve la gramtica vaca.
	 *
	 */
	public CNFContextFreeGrammar ()
	{
		super();
	}
		
	/**
	 * Construye una gramtica a partir de un fichero en formato Susanne.
	 * @param f Fichero de donde se leer la gramtica (formato Susanne)
	 */
	public CNFContextFreeGrammar ( File f )
	{
		super( f );	
	}
	
	public void initFromFile ( File f )
	{
		super.initFromFile(f);
		ContextFreeGrammar chomsky = this.chomskyNormalForm();
		this.clear();
		this.addAll(chomsky);
	}
	
	public Element[] getEntity ( int i )
	{
		return (Element[])super.get(i);
	}
	
	
	
}