/*Code Generated for File: Main.java*/

/*
 * Created on 15-ago-2004 17:16:19
 *
 */
package test;

import grammar.ContextFreeGrammar;
import element.*;
import schema.item.*;
import schema.step.*;

import java.io.BufferedReader;
import java.io.File;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;
import java.util.LinkedList;


public class Main
{
	
	static LinkedList agenda = new LinkedList();
	
	public static void main ( String[] args ) throws Throwable
	{
		
		SymbolTable.reset();
		
		BufferedReader br = new BufferedReader ( new InputStreamReader(System.in));
		String linea;
		
		ContextFreeGrammar cfg = null;
		
		try
		{
			cfg = new ContextFreeGrammar(new File("DefaultGrammar"));
		}
		catch ( Exception e )
		{
				System.err.println("[WARNING] Use the GUI (test.ParserInterface) if you want the grammar file to be configurable.");
				throw e;
		}
		if ( cfg.size() < 1 )
		{
			System.err.println("[WARNING] Use the GUI (test.ParserInterface) if you want the grammar file to be configurable.");
			System.err.println("Right now I'm working with the empty grammar.");
		}
		//System.out.println(cfg.chomskyNormalForm());
		//System.out.println("Pasando a forma normal de Chomsky...");
		//cfg = cfg.chomskyNormalForm();
		//System.out.println("Chomsky OK.");
		
		while ( (linea=br.readLine()) != null )
		{
			StringTokenizer st = new StringTokenizer( linea );
			//leer terminales de fichero
			List tokens = new ArrayList(); //of items
			int sentencelen = 0;
			//apply k-function to generate items from sentence!!
			while ( st.hasMoreTokens() )
			{
				String tokText = st.nextToken().trim();
				Symbol tokSym = SymbolTable.instance().symbolFor(tokText.replace(':','%').trim());
				Element[] item = new Element[3];
				item[0] = tokSym;
				item[1] = StringPosition.groundFromValue(sentencelen);
				sentencelen++;
				item[2] = StringPosition.groundFromValue(sentencelen);
				tokens.add(item);
			}
			//new ItemHandler ( sentencelen , SymbolTable.instance().getLastId()+ 1 );
			StringPosition.setMaxValue(sentencelen);
			new ItemHandler();
			for ( int i = 0 ; i < tokens.size() ; i++ )
			{
				ItemHandler.instance().addItem((Element[])tokens.get(i));
				agenda.add ( (Element[]) tokens.get(i) );
			}
			doIt(cfg);
		}
	}
	
	/**
	 * Este codigo en principio no es generado, es siempre el mismo.
	 *
	 */
	public static void doIt( ContextFreeGrammar cfg ) //uses agenda.
	{
		List pasosDeductivos = StepFactory.instanceSteps ( cfg );
		System.out.println("Step instantiation completed.\n");
		List empty = new ArrayList();
		
		System.out.println("Deductive Steps:" + pasosDeductivos.size());
		
		long time1 = System.currentTimeMillis();
		
		//Aplicar pasos de antecedente vacio y quitarlos de la lista de pasos aplicables.
		int sz = pasosDeductivos.size();
		Object[] emptyItem = new Object[0];
		for ( int i = sz-1 ; i >= 0 ; i-- )
		{
			List l = ((DeductiveStep)pasosDeductivos.get(i)).applyTo(emptyItem);
			if ( l!=null )
			{
				for ( int j = 0 ; j < l.size() ; j++ )
				{
						Object[] newItem = (Object[]) l.get(j);
						if ( !ItemHandler.instance().exists(newItem) )
						{
							ItemHandler.instance().addItem(newItem);
							agenda.add(newItem);
						}
				}
				if ( l.size() > 0 )
				{
					if ( ((DeductiveStep)pasosDeductivos.get(i)).hasEmptyAntecedent() )
						pasosDeductivos.remove(i);
				}
			}
		}
		
		//inicializar StepHandler
		new StepHandler();
		sz = pasosDeductivos.size();
		for ( int i = 0 ; i < sz ; i++ )
		{
			StepHandler.instance().addStep((DeductiveStep)pasosDeductivos.get(i));
		}
		
		while ( !agenda.isEmpty() )
		{
			Object[] curItem = (Object[]) agenda.removeFirst();
			
			List pasosDeductivosAplicables = StepHandler.instance().getByItem(curItem);
			
			sz = pasosDeductivosAplicables.size();
			for ( int i = 0 ; i < sz ; i++ )
			{
				List l = ((DeductiveStep)pasosDeductivosAplicables.get(i)).applyTo(curItem);
				if ( l != null )
				{
					int sz2 = l.size();
					for ( int j = 0 ; j < sz2 ; j++ )
					{
						Object[] newItem = (Object[]) l.get(j);
						if ( !ItemHandler.instance().exists(newItem) )
						{
						    //System.out.println("Adding " + ItemHandler.instance().getAll().size() + ":" + Items.toString(newItem) + " by " + ((DeductiveStep)pasosDeductivosAplicables.get(i)).getClass().getName());
							ItemHandler.instance().addItem(newItem);
							agenda.add(newItem);
						}
					}
				}
			}
		}
		
		long time2 = System.currentTimeMillis();
		
		System.out.println(agenda);
		List lItems = (ItemHandler.instance().getAll());
		
		System.out.println("FINAL ITEMS: ");
		
		for ( int i = 0 ; i < lItems.size() ; i++ )
		{
			Object[] item = (Object[]) lItems.get(i);
			System.out.println(Items.toString(item));
		}
		
		System.out.println("(" + lItems.size() + " items were generated" + ")");
		System.out.println("("+(time2-time1) + " milliseconds were elapsed)");
		System.out.println( (double)lItems.size()/(time2-time1)*1000 + " items processed per second"  );
		
	}
	
	
	
	
	
	
}
