package agenda;
import java.util.LinkedList;
import java.util.List;
import java.util.NoSuchElementException;

/**
 * Implementation of Agenda delegating the interface's methods in a LinkedList.
 * This implementation provides a standard agenda with the behaviour of a FIFO queue.
 * The item considered the "first" is always the one which was first inserted
 * into the agenda.
 * @author carlos
 *
 * Created at regulus, 11-nov-2006 12:30:35
 */
public class SimpleQueueAgenda implements Agenda
{

	private LinkedList theList = new LinkedList();
	
	public boolean add ( Object item )
	{
		return theList.add(item);
	}
	
	/**
	 * Removes and returns the first item of the agenda.
	 * The first item in this case is the one which was inserted first among the remaining elements.
	 * @return The oldest item in the agenda.
	 * @throws NoSuchElementException if the agenda is empty.
	 */
	public Object removeFirst ( ) throws NoSuchElementException
	{
		return theList.removeFirst();
	}
	
	public boolean isEmpty()
	{
		return theList.isEmpty();
	}
	
	public int size()
	{
		return theList.size();
	}
	
	public void clear()
	{
		theList.clear();
	}
	
}