/*
 * Created at regulus on 25-dic-2005 19:03:07
 * as file FeatureStructureFromLispReader.java on package grammar.tag
 */
package grammar.tag.util;

import element.SymbolTable;
import element.tag.TAGTree;
import grammar.IncorrectGrammarFormatException;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.StringTokenizer;
import java.util.TreeSet;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Text;
import org.xml.sax.SAXException;

import util.DOMNodeListWrapper;
import util.DOMNodeWrapper;

/**
 * @author carlos
 *
 * Created at regulus, 25-dic-2005 19:03:07
 */
public class FeatureStructureFromLispReaderOld
{

	//Gets a tree-adjoining grammar from an XML file, adds features from
	//XTAG LISP files and writes XML with features to a file.
	
	private HashMap treeNamesToFeatures;
	
	
	//changes spaces to 's.
	private String normalizeFeatureName ( String featName )
	{
		/*
		if (featName.indexOf(" ")>=0)
		{
			System.out.println(featName.indexOf(" "));
			System.out.println(featName.replace(' ','8'));
		}
		if ( featName.startsWith("") && featName.length() > 3 )
			System.out.println("Name:" + featName);
		return featName.replace(' ','_');
		*/
		//Not necessary to do anything!
		return featName;
	}
	
	
	public void readFeaturesFromLispDirectory ( File treeFilesDir ) throws Throwable
	{
		List associations1 = new ArrayList();
		String[] dir = treeFilesDir.list();
		for ( int i = 0 ; i < dir.length ; i++ )
		{
			File f = new File ( treeFilesDir , dir[i] );
			if ( f.isFile() )
			{
				readFeaturesFromLispFile ( f , associations1 );
			}
		}
		
		for ( int i = 0 ; i < associations1.size() ; i++ )
		{
			//System.out.println(associations1.get(i));
		}
		System.out.println("Trees processed: " + associations1.size());
		
		expandCompositeFeatures(associations1);
		
		Set ofTreeNames = new TreeSet();
		for ( int i = 0 ; i < associations1.size() ; i++ )
		{
			TreeEquationsAssociation1 tea1 = (TreeEquationsAssociation1) associations1.get(i);
			ofTreeNames.add(tea1.treeName);
		}
		Iterator it = ofTreeNames.iterator();
		while ( it.hasNext() ) System.out.println(it.next());
		//System.out.println(ofTreeNames.size());
		
		List associations2 = new ArrayList();
		
		for ( int i = 0 ; i < associations1.size() ; i++ )
		{
			TreeEquationsAssociation1 tea1 = (TreeEquationsAssociation1) associations1.get(i);
			TreeEquationsAssociation2 tea2 = new TreeEquationsAssociation2 ( tea1 );
			
			associations2.add(tea2);
			//System.out.println(tea2);
		}
		
		
		try
		{
			DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
			factory.setValidating(true);
			factory.setNamespaceAware(true);
			DocumentBuilder builder = factory.newDocumentBuilder();
			Document document = builder.parse( new File("C:\\Proyecto\\Version8\\Grammars\\bigtag\\big-english-nodtd2.xml") );
			
			DOMNodeWrapper root = new DOMNodeWrapper ( document.getDocumentElement() );
			
			/*
			//axiom
			String axiomStr = root.getAttribute("axiom");
			if ( axiomStr == null )
				throw new IncorrectGrammarFormatException("tag node lacking attribute axiom");
			axiom = SymbolTable.instance().symbolFor(axiomStr);
			
			
			//family (trees) file
			String famFileStr = root.getAttribute("familyfile");
			File fTrees = new File(f.getParentFile(),famFileStr);
			Document docTrees = builder.parse(fTrees);
			DOMNodeWrapper rootTrees = new DOMNodeWrapper ( docTrees.getDocumentElement() );
			
			//lemma file
			String lemmaFileStr = root.getAttribute("lemmafile");
			File fLemmas = new File(f.getParentFile(),lemmaFileStr);
			Document docLemmas = builder.parse(fLemmas);
			DOMNodeWrapper rootLemmas = new DOMNodeWrapper ( docLemmas.getDocumentElement() );
			
			//lex file
			String lexFileStr = root.getAttribute("lexfile");
			File fLex = new File(f.getParentFile(),lexFileStr);
			Document docLex = builder.parse(fLex);
			DOMNodeWrapper rootLex = new DOMNodeWrapper ( docLex.getDocumentElement() );
			*/
			
			int yesFound = 0;
			int notFound = 0;
			
			DOMNodeWrapper rootTrees = root;
			
			System.out.println("Writing feature structures to XML...");
			
			//tree families
			DOMNodeListWrapper famNodes = rootTrees.getElementsByTagName("family");
			for ( int i = 0 ; i < famNodes.size() ; i++ )
			{
				DOMNodeListWrapper treeNodes = famNodes.get(i).getElementsByTagName("tree");
				for ( int j = 0 ; j < treeNodes.size() ; j++ )
				{
					DOMNodeWrapper treeNode = treeNodes.get(j);
					boolean found = initTreeFeatures ( treeNode , associations2 , document );
					if ( found )
						yesFound++;
					else
						notFound++;
				}
			}
			
			//single trees
			DOMNodeListWrapper singNodes = rootTrees.getElementsByTagName("single-tree");
			for ( int i = 0 ; i < singNodes.size() ; i++ )
			{
				DOMNodeListWrapper treeNodes = singNodes.get(i).getElementsByTagName("tree");
				for ( int j = 0 ; j < treeNodes.size() ; j++ )
				{
					DOMNodeWrapper treeNode = treeNodes.get(j);
					boolean found = initTreeFeatures ( treeNode , associations2 , document );
					if ( found )
						yesFound++;
					else
						notFound++;
				}
			}
			
			System.out.println(yesFound + " trees from XML found on LISP file");
			System.out.println(notFound + " trees were not found");
			
			System.out.println("Going to write XML output");
			
			Transformer t = TransformerFactory.newInstance().newTransformer();
			t.transform(new DOMSource(document),new StreamResult(new File("C:\\Proyecto\\Version9\\Grammars\\bigtag\\transformed5.xml")));
			
			System.out.println("Now we're going to apply newer transformations.");
			
			
			Binarizer bin = new Binarizer( "C:\\Proyecto\\Version9\\Grammars\\bigtag\\transformed5.xml","C:\\Proyecto\\Version9\\Grammars\\bigtag\\transformed8.xml" , new AnchorDoubler(new EpsilonRenamer("emptystring",null)) );
			bin.process();
			AnchorDoubler trans = new AnchorDoubler ( "C:\\Proyecto\\Version9\\Grammars\\bigtag\\transformed5.xml","C:\\Proyecto\\Version9\\Grammars\\bigtag\\transformed7.xml",new EpsilonRenamer("emptystring",null) );
			trans.process();
			
			/*
			Binarizer bin = new Binarizer( "C:\\Proyecto\\Version9\\Grammars\\subset1.xml","C:\\Proyecto\\Version9\\Grammars\\bigtag\\subset1bin.xml" , new AnchorDoubler(new EpsilonRenamer("emptystring",null)) );
			bin.process();
			*/
			
		}
		catch ( ParserConfigurationException pce )
		{
			throw new IncorrectGrammarFormatException(pce);
		}
		catch ( SAXException se )
		{
			se.printStackTrace();
			throw new IncorrectGrammarFormatException(se);
		}
		
		
		
	}
	
	public boolean initNodeFeatures ( String treeName , DOMNodeWrapper nodeNode , List tea2 , Document doc )
	{
		String nodeName = nodeNode.getAttribute("id");
		
		DOMNodeListWrapper children = nodeNode.getDirectChildrenElementsByTagName("node");
		
		//remove existing features
		DOMNodeListWrapper nargNodes = nodeNode.getDirectChildrenElementsByTagName("narg");
		for ( int i = 0 ; i < nargNodes.size() ; i++ )
		{
			nodeNode.getNode().removeChild(nargNodes.get(i).getNode());
		}
		
		//init features
		//System.out.println("Tree " + treeName + ":");
		boolean found = false; //tree found?
		boolean nodeFound = false; //node features found?
		for ( int i = 0 ; i < tea2.size() ; i++ )
		{
			TreeEquationsAssociation2 theTea = (TreeEquationsAssociation2) tea2.get(i);
			if ( theTea.treeName.equalsIgnoreCase(treeName) )
			{				
				
				found = true;
				
				List bottomFeatures = theTea.getNodeFeatures(true,nodeName);
				List topFeatures = theTea.getNodeFeatures(false,nodeName);
				
				if ( topFeatures.size() == 0 && bottomFeatures.size() == 0 )
				{
					System.out.println("Couldn't find features for node " + nodeName + "@" + treeName);
				
					bottomFeatures = theTea.getNodeFeatures(true,nodeName.substring(0,nodeName.indexOf("_")));
					topFeatures = theTea.getNodeFeatures(false,nodeName.substring(0,nodeName.indexOf("_")));
				
					if ( topFeatures.size() == 0 && bottomFeatures.size() == 0 )
						;
					else
						System.out.println("Fallback method succeeded on this node");
					
				}
				
				
				Element bot = doc.createElement("narg");
				bot.setAttribute("type","bot");
				Element fsbot = doc.createElement("fs");
				bot.appendChild(fsbot);
				for ( int k = 0 ; k < bottomFeatures.size() ; k++ )
				{
					TreeEquationsAssociation2.SingleFeatureAssociationOld sfa =
						(TreeEquationsAssociation2.SingleFeatureAssociationOld) bottomFeatures.get(k);
					Element e = doc.createElement("f");
					e.setAttribute("name",normalizeFeatureName(sfa.featName));
					if ( sfa.value != null )
					{
						Element e2 = doc.createElement("val");
						Text t = doc.createTextNode(sfa.value);
						e2.appendChild(t);
						e.appendChild(e2);
					}
					if ( sfa.link != null )
					{
						Element e2 = doc.createElement("link");
						e2.setAttribute("id",sfa.link);
						e.appendChild(e2);
					}
					fsbot.appendChild(e);
				}
				
				Element top = doc.createElement("narg");
				top.setAttribute("type","top");
				Element fstop = doc.createElement("fs");
				top.appendChild(fstop);
				for ( int k = 0 ; k < topFeatures.size() ; k++ )
				{
					TreeEquationsAssociation2.SingleFeatureAssociationOld sfa =
						(TreeEquationsAssociation2.SingleFeatureAssociationOld) topFeatures.get(k);
					Element e = doc.createElement("f");
					e.setAttribute("name",normalizeFeatureName(sfa.featName));
					if ( sfa.value != null )
					{
						Element e2 = doc.createElement("val");
						Text t = doc.createTextNode(sfa.value);
						e2.appendChild(t);
						e.appendChild(e2);
					}
					if ( sfa.link != null )
					{
						Element e2 = doc.createElement("link");
						e2.setAttribute("id",sfa.link);
						e.appendChild(e2);
					}
					fstop.appendChild(e);
				}
				
				org.w3c.dom.Node n = nodeNode.getNode().getFirstChild();
				
				if ( n == null )
				{
					nodeNode.getNode().appendChild(top);
					nodeNode.getNode().appendChild(bot);
				}
				else
				{
					nodeNode.getNode().insertBefore(top,n);
					nodeNode.getNode().insertBefore(bot,n);
				}
				
				
			}
		}

			

		
		//recursive call on children
		
		for ( int i = 0 ; i < children.size() ; i++ )
		{
			initNodeFeatures ( treeName , children.get(i) , tea2 , doc );
		}
		
		return found;
		
	}
	
	public boolean initTreeFeatures ( DOMNodeWrapper treeNode , List tea2 , Document doc )
	{	
		String treeName = treeNode.getAttribute("name");
		DOMNodeListWrapper nodes = treeNode.getDirectChildrenElementsByTagName("node");
		boolean found = false;
		for ( int i = 0 ; i < nodes.size() ; i++ )
		{
			found = initNodeFeatures ( treeName , nodes.get(i) , tea2 , doc );
		}
		return found;
	}
	
	class InfernalFormatParseException extends Exception
	{
		public InfernalFormatParseException ( String message )
		{
			super(message);
		}
	}
	
	public void readFeaturesFromLispFile ( File f , List associationList ) throws Throwable
	{
		
		System.out.println("File: " + f);
		
		//read full file to a string
		FileReader fr = new FileReader(f);
		StringWriter sw = new StringWriter();
		BufferedReader br = new BufferedReader ( fr );
		BufferedWriter bw = new BufferedWriter ( sw );
		
		int len = (int)f.length();
		char[] buff = new char[len];
		int readLen;
		
		//pasamos de un fichero a otro a travs del buffer
		while ( (readLen = br.read(buff,0,len)) > 0 )
			bw.write(buff,0,len);
		
		br.close();
		
		StringBuffer sb = sw.getBuffer();
		
		bw.close();
		
		String fullFile = sb.toString();
		
		//parse infernal format
		String lookahead = null;
		String curToken = null;
		
		StringTokenizer st = new StringTokenizer ( fullFile, " \n\r\t=");
		
		String currentTreeName = null;
		
		List associations1 = new ArrayList();
		
		while ( st.hasMoreTokens() )
		{
			lookahead = st.nextToken();
			
			if ( lookahead.startsWith(":COMMENT-DISPLAY?") )
			{
				//curToken holds tree name
				StringBuffer buf = new StringBuffer();
				for ( int i = 0 ; i < curToken.length(); i++ )
				{
					char ch = curToken.charAt(i);
					if ( Character.isLetterOrDigit(ch) )
						buf.append(ch);
				}
				currentTreeName = buf.toString();
			}
			
			if ( lookahead.startsWith(":UNIFICATION-EQUATIONS") )
			{
				lookahead = st.nextToken(); //comillas y posiblemente algo
				lookahead = lookahead.substring(1);
				//read unification equations
				List leftSides = new ArrayList();
				List rightSides = new ArrayList();
				final int LEFT = 0;
				//final int EQUAL = 1;
				final int RIGHT = 2;
				int parserState = LEFT;
				while ( st.hasMoreTokens() )
				{
					if ( lookahead.startsWith("\"") || lookahead.startsWith(":") )
					{
						//end read unification equations
						TreeEquationsAssociation1 assoc =
							new TreeEquationsAssociation1 ( currentTreeName , leftSides , rightSides );
						associations1.add(assoc);
						break;
					}
					else if ( lookahead.trim().length() == 0 )
					{
						lookahead = st.nextToken();
						continue;
					}
					else
					{
						if ( parserState == LEFT )
						{

							
							if ( lookahead.indexOf("<") >= 0 && lookahead.indexOf(">") < 0 )
							{
								lookahead += " ";
								lookahead += st.nextToken();
							}
							//System.out.println("L:"+lookahead);
							leftSides.add(lookahead);
							//parserState = EQUAL;
							parserState = RIGHT;
						}
						else if ( parserState == RIGHT )
						{
							if ( lookahead.indexOf("<") >= 0 && lookahead.indexOf(">") < 0 )
							{
								lookahead += " ";
								lookahead += st.nextToken();
							}
							//System.out.println("R:"+lookahead);
							rightSides.add(lookahead);
							parserState = LEFT;
						}
						/*
						else
						{
							if ( !lookahead.equals("=") )
								throw new InfernalFormatParseException("Equal expected, " + lookahead + " found!");
							parserState = RIGHT;
						}
						*/
					}
					//System.out.println("ru");
					lookahead = st.nextToken();
				} //while
				
			}
			
			
			curToken = lookahead;
		}
		
		
		associationList.addAll(associations1);
		
	}
	
	
	public void expandCompositeFeatures ( List ofTreeEquationsAssociation1 )
	{
		//expands agr to agr sing, agr plur, etc. etc.
	
		for ( int i = 0 ; i < ofTreeEquationsAssociation1.size() ; i++ )
		{
			TreeEquationsAssociation1 tea = (TreeEquationsAssociation1) ofTreeEquationsAssociation1.get(i);
			System.out.println("B4: " + tea.leftSides.size());
			for ( int j = 0 ; j < tea.leftSides.size() ; j++ )
			{
				String leftSide = (String) tea.leftSides.get(j);
				String rightSide = (String) tea.rightSides.get(j);
				System.out.println("L: " + leftSide);
				if ( leftSide.indexOf("<agr>") >= 0 || rightSide.indexOf("<agr>") >= 0 )
				{
					
					String newLeftSide1 = leftSide.replaceAll("<agr>","<agr pers>");
					System.out.println("REPL" + newLeftSide1);
					String newRightSide1 = rightSide.replaceAll("<agr>","<agr pers>");
					String newLeftSide2 = leftSide.replaceAll("<agr>","<agr 3rdsing>");
					String newRightSide2 = rightSide.replaceAll("<agr>","<agr 3rdsing>");
					String newLeftSide3 = leftSide.replaceAll("<agr>","<agr num>");
					String newRightSide3 = rightSide.replaceAll("<agr>","<agr num>");
					tea.leftSides.remove(leftSide);
					tea.rightSides.remove(rightSide);
					tea.leftSides.add(newLeftSide1);
					tea.leftSides.add(newLeftSide2);
					tea.leftSides.add(newLeftSide3);
					tea.rightSides.add(newRightSide1);
					tea.rightSides.add(newRightSide2);
					tea.rightSides.add(newRightSide3);
					j--; //quitamos un elemento de la lista. Si no hicisemos esto
					//nos estaramos saltando un elemento.
				}
			}
			System.out.println("AF: " + tea.leftSides.size());
			for ( int k = 0 ; k < tea.leftSides.size() ; k++ )
			{
				String s = (String) tea.leftSides.get(k);
				System.out.println("#" + s);
				if ( s.indexOf("<agr>") >= 0 )
				{
					System.out.println("BAD THING!!!");
				}
			}
		}
		
	}
	
	
	class TreeEquationsAssociation2
	{
		private String treeName;
		private List featureAssociations = new ArrayList();
		
		class SingleFeatureAssociationOld
		{
			String nodeName;
			boolean bottom;
			String featName;
			String value;
			String link;
		
			public boolean equals ( Object o )
			{
				if ( !(o instanceof SingleFeatureAssociationOld) )
					return false;
				SingleFeatureAssociationOld sfa = (SingleFeatureAssociationOld) o;
				if ( sfa.bottom != this.bottom ) return false;
				if ( sfa.nodeName == null )
				{
					if ( this.nodeName != null ) return false;
				}
				else if ( !sfa.nodeName.equals(this.nodeName) ) return false;
				if ( sfa.featName == null )
				{
					if ( this.featName != null ) return false;
				}
				else if ( !sfa.featName.equals(this.featName) ) return false;
				if ( sfa.value == null )
				{
					if ( this.value != null ) return false;
				}
				else if ( !sfa.value.equals(this.value) ) return false;
				if ( sfa.link == null )
				{
					if ( this.link != null ) return false;
				}
				else if ( !sfa.link.equals(this.link) ) return false;
				return true;
			}
		
		}
		
		public List getNodeFeatures ( boolean bottom ,  String nodeName )
		{
			List result = new ArrayList();
			for ( int i = 0 ; i < featureAssociations.size() ; i++ )
			{
				SingleFeatureAssociationOld sfa = (SingleFeatureAssociationOld)
					featureAssociations.get(i);
				if ( sfa.bottom == bottom && sfa.nodeName.equals(nodeName) )
					result.add ( sfa );
			}
			return result;
		}
		
		public String toString()
		{
			StringBuffer sb = new StringBuffer();
			sb.append("TREE NAME: " + treeName);
			for ( int i = 0 ; i < featureAssociations.size() ; i++ )
			{
				SingleFeatureAssociationOld sfa = (SingleFeatureAssociationOld) featureAssociations.get(i);
				sb.append(sfa.nodeName+",");
				sb.append("bottom="+sfa.bottom+",");
				sb.append("featname="+sfa.featName+",");
				sb.append("val="+sfa.value+",");
				sb.append("link="+sfa.link+".");
				sb.append("\n");
			}
			return new String(sb);
		}
		
		public TreeEquationsAssociation2 ( TreeEquationsAssociation1 assoc1 )
		{
			this.treeName = assoc1.treeName;
			
			List equivalenceClasses = new ArrayList();
			for ( int i = 0 ; i < assoc1.leftSides.size() ; i++ )
			{
				String leftSide = (String)assoc1.leftSides.get(i);
				String rightSide = (String)assoc1.rightSides.get(i);
				
				/*
				System.out.println(leftSide + " ## " + rightSide);
				System.out.println(leftSide.indexOf("."));
				*/
				
				if ( leftSide.indexOf(".") < 0 )
				{
					//Special case: doesn't specify top or bottom. We add the corresponding top, bottom eq's to the list.
					String lPart1 = leftSide.substring(0,leftSide.indexOf(":"));
					String lPart2 = leftSide.substring(leftSide.indexOf(":")+1);
					
					String newLeftSideTop = lPart1 + ".t" + ":" + lPart2;
					String newLeftSideBottom = lPart1 + ".b" + ":" + lPart2;
					
					assoc1.leftSides.add(i+1,newLeftSideTop);
					assoc1.leftSides.add(i+1,newLeftSideBottom);
					assoc1.rightSides.add(i+1,rightSide);
					assoc1.rightSides.add(i+1,rightSide);
					
					//System.err.println("EQUATION IGNORED: " + leftSide + " = " + rightSide);
					
					continue;
				}
				
				if ( rightSide.indexOf(".") < 0 && rightSide.indexOf(":") >= 0 )
				{
					//Same as before with right side
					//extra if comparison required for right side can be a value instead of a reference
					String rPart1 = rightSide.substring(0,rightSide.indexOf(":"));
					String rPart2 = rightSide.substring(rightSide.indexOf(":")+1);
					
					String newRightSideTop = rPart1 + ".t" + ":" + rPart2;
					String newRightSideBottom = rPart1 + ".b" + ":" + rPart2;
					
					assoc1.rightSides.add(i+1,newRightSideTop);
					assoc1.rightSides.add(i+1,newRightSideBottom);
					assoc1.leftSides.add(i+1,leftSide);
					assoc1.leftSides.add(i+1,leftSide);
					
					//System.err.println("EQUATION IGNORED: " + leftSide + " = " + rightSide);
					
					continue;
				}
				
				
				SingleFeatureAssociationOld sfa = new SingleFeatureAssociationOld();
				sfa.nodeName = leftSide.substring(0,leftSide.indexOf("."));
				String topOrBot = leftSide.substring(leftSide.indexOf(".")+1,leftSide.indexOf(":"));
				if ( topOrBot.equals("b") ) sfa.bottom = true; else sfa.bottom = false;
				String featName = leftSide.substring(leftSide.indexOf("<")+1,leftSide.indexOf(">"));
				sfa.featName = featName;
				
				//value or link?
				if ( rightSide.indexOf("<") < 0 )
				{
					//value
					sfa.value = rightSide;
					if ( !featureAssociations.contains(sfa) )
						featureAssociations.add(sfa);
				}
				else
				{
					
					boolean continueOuterLoop = false;
					//link.
					//first see if any of both has been asigned a link already.
					for ( int j = 0 ; j < equivalenceClasses.size() ; j++ )
					{
						Set eqClass = (Set) equivalenceClasses.get(j);
						if ( eqClass.contains(leftSide) || eqClass.contains(rightSide) )
						{
							if ( eqClass.contains(leftSide) )
							{
								eqClass.add(rightSide);
								sfa.link = "X"+j;
								if ( !featureAssociations.contains(sfa) )
									featureAssociations.add(sfa);
								continueOuterLoop = true;
							}
							if ( eqClass.contains(rightSide) )
							{
								eqClass.add(leftSide);
								//create right SFA
								SingleFeatureAssociationOld sfa2 = new SingleFeatureAssociationOld();
								
								if ( rightSide.indexOf(".") < 0 )
								{
									System.err.println("EQUATION IGNORED: " + leftSide + " = " + rightSide);
									continueOuterLoop = true;
									break;
								}
								
								sfa2.nodeName = rightSide.substring(0,rightSide.indexOf("."));
								String topOrBot2 = rightSide.substring(rightSide.indexOf(".")+1,rightSide.indexOf(":"));
								if ( topOrBot2.equals("b") ) sfa2.bottom = true; else sfa2.bottom = false;
								String featName2 = rightSide.substring(rightSide.indexOf("<")+1,rightSide.indexOf(">"));
								sfa2.featName = featName2;
								
								sfa2.link = "X"+j;
								if ( !featureAssociations.contains(sfa2) )
									featureAssociations.add(sfa2);
								continueOuterLoop = true;
							}
						}
						
					}
					
					if ( continueOuterLoop )
						continue;
					
					//if they haven't been seen, create a new link and an eq. class
					Set newEqClass = new TreeSet();
					newEqClass.add(leftSide);
					newEqClass.add(rightSide);
					equivalenceClasses.add(newEqClass);
					sfa.link = "X"+(equivalenceClasses.size()-1);
					if ( !featureAssociations.contains(sfa) )
						featureAssociations.add(sfa);
					
					//create right SFA
					SingleFeatureAssociationOld sfa2 = new SingleFeatureAssociationOld();
					
					if ( rightSide.indexOf(".") < 0 )
					{
						System.err.println("EQUATION IGNORED: " + leftSide + " = " + rightSide);
						continueOuterLoop = true;
						break;
					}
					
					sfa2.nodeName = rightSide.substring(0,rightSide.indexOf("."));
					String topOrBot2 = rightSide.substring(rightSide.indexOf(".")+1,rightSide.indexOf(":"));
					if ( topOrBot2.equals("b") ) sfa2.bottom = true; else sfa2.bottom = false;
					String featName2 = rightSide.substring(rightSide.indexOf("<")+1,rightSide.indexOf(">"));
					sfa2.featName = featName2;
					
					sfa2.link = "X"+(equivalenceClasses.size()-1);
					if ( !featureAssociations.contains(sfa2) )
						featureAssociations.add(sfa2);

					

				} //else (link processing)
			
			} //foreach unification equation
		} //constructor TreeEquationsAssociation2
		
		
	}
	
	class TreeEquationsAssociation1
	{
		private String treeName;
		private List leftSides;
		private List rightSides;
		
		public TreeEquationsAssociation1 ( String treeName , List leftSides , List rightSides )
		{
			this.treeName = treeName;
			this.leftSides = leftSides;
			this.rightSides = rightSides;
		}
		
		public String toString()
		{
			StringBuffer sb = new StringBuffer();
			sb.append("TREE: " + treeName + "\n");
			//System.out.println(leftSides.size() + " : " + rightSides.size());
			for ( int i = 0 ; i < leftSides.size() ; i++ )
			{
					try
					{
						sb.append("* "+leftSides.get(i) + " = " + rightSides.get(i)+"\n");
					}
					catch ( Exception e )
					{
						System.err.println("BUFFER: " + sb);
						System.err.println("OFFENDING STRING: " + leftSides.get(i));
						System.exit(1);
					}
			}

			return new String(sb);
		}
		
	}
	
	
	
	//test, driver method
	public static void main ( String[] args ) throws Throwable
	{
		
		FeatureStructureFromLispReaderOld reader = new FeatureStructureFromLispReaderOld();
		reader.readFeaturesFromLispDirectory ( new File("C:\\NLPResources\\xtagold99\\english\\grammar") );
		/*
		TreeAdjoiningGrammar tag = new TreeAdjoiningGrammar();
		tag.initFromFile( new File("C:\\proyecto\\version8\\grammars\\bigtag\\big-english-nodtd2.xml") );
		
		int iniTrees = 0;
		int nNodes = 0;
		for ( int i = 0 ; i < tag.trees.size() ; i++ )
		{
			if ( ((TAGTree)tag.trees.get(i)).isInitial() )
				iniTrees++;
			nNodes += ((TAGTree)tag.trees.get(i)).numNodes();
		}
		
		System.out.println("Trees: " + tag.trees.size());
		System.out.println("Initial trees: " + iniTrees);
		System.out.println("Auxiliary trees: " + (tag.trees.size()-iniTrees));
		System.out.println("Tree nodes: " + nNodes);
		System.out.println("CFG rules: " + tag.rules.size());
		*/
	}

	
}
