package parser.sparser.tree;
/**
 * Nodo que representa el antecedente de un paso deductivo.
 */
public class AntecedentNode implements ParseTreeNode
{
	private Object[] components;
	public AntecedentNode ( Object[] comps )
	{
		components = comps;
	}
	
	public String toString()
	{
		String result = "";
		for ( int i = 0 ; i < components.length ; i++ )
		{
			result += components[i].toString();
			if ( i < components.length-1 )
				result += "\n";
		}
		return ( result );
	}
	
	public int numChildren()
	{
		return components.length;
	}
	
	public ParseTreeNode getChild(int i)
	{
		return (ParseTreeNode) components[i];
	}
	
}