package parser.sparser.tree;
/**
Nodo correspondiente a un Item.
Esto, luego en la mquina deductiva, ser un simple Object[] no distinguible
de otro composite como p.ej. una regla.
*/
public class ItemNode implements ParseTreeNode
{
	
	private Object[] components;
	
	/*Nos dice si el tem est negado (es decir, si es una condicin de no existencia)*/
	/*(added 2006-11-05)*/
	private boolean negated;
	
	
	public boolean isNegated()
	{
		return negated;
	}
	
	public void setNegated( boolean negated )
	{
		this.negated = negated;
	}
	
	public ItemNode ( Object[] comps )
	{
		components = comps;
	}
	
	public ItemNode ( Object[] comps , boolean negated )
	{
		this.negated = negated;
	}
	
	public String toString()
	{
		String result = "";
		if ( negated ) result += "NOT ";
		result += "[";
		for ( int i = 0 ; i < components.length ; i++ )
		{
			result += components[i].toString();
			if ( i < components.length-1 )
				result += " , ";
		}
		return ( result + "]" );
	}
	
	public int numChildren()
	{
		return components.length;
	}
	
	public ParseTreeNode getChild(int i)
	{
		return (ParseTreeNode) components[i];
	}
	
}